<?php
header('Content-Type: text/html; charset=utf-8');
header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0');
header('Pragma: no-cache');
?>
<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />	
	
	<title>
		به بانک | درگاه بانکی و کیف پول الکترونیکی
	</title>
	
	<style type="text/css">
		* {
			text-align:right;
			direction:rtl;
			font-family:tahoma;
			font-weight:normal;
			font-size:12px;
		}

		.panel {
			background-color: #fff;
			border: 1px solid transparent;
			border-radius: 4px;
			box-shadow: 0 1px 1px rgba(0, 0, 0, 0.05);
			margin-bottom: 20px;
		}
		.panel-primary {
			border-color: #337ab7;
		}
		.panel-primary > .panel-heading {
			background-color: #337ab7;
			border-color: #337ab7;
			color: #fff;
			border-bottom: 1px solid transparent;
			border-top-left-radius: 3px;
			border-top-right-radius: 3px;
			padding: 10px 15px;
		}
		.panel-body {
			padding: 15px;
		}
		table {
			border-collapse: separate;
			border-spacing: 2px;
			box-sizing: border-box;
			display: table;
			text-indent: 0;
			width: 100%;
		}
		tbody {
			display: table-row-group;
			vertical-align: middle;
		}
		tr {
			display: table-row;
			vertical-align: inherit;
		}
		td {
			display: table-cell;
			padding: 1px;
			text-align: inherit;
			vertical-align: inherit;
			padding: 9px;
			
		}
		.table-striped > tbody > tr:nth-of-type(2n+1) {
			background-color: #f9f9f9;
		}
		.btn {
			-moz-user-select: none;
			background-image: none;
			border: 1px solid transparent;
			border-radius: 4px;
			cursor: pointer;
			display: inline-block;
			font-size: 14px;
			font-weight: 400;
			line-height: 1.42857;
			margin-bottom: 0;
			padding: 6px 12px;
			text-align: center;
			vertical-align: middle;
			white-space: nowrap;
		}
		.btn-success {
			background-color: #5cb85c;
			border-color: #4cae4c;
			color: #fff;
		}
		input {
			border: 1px solid #cfcfcf;
			border-radius: 5px;
			padding: 7px;
			width: 70%;
			text-align:left;
			direction:ltr;
		}
	</style>
</head>
<body class="rtl">
	<div id="container">
		<div id="row">
			<div class="col-sm-6" style="margin:0 25% !important">	
				<br>
				<div class="panel panel-primary">
					<div class="panel-heading">نمایش اطلاعات سرور پذیرنده</div>
					<div class="panel-body">
						<table class="table table-striped">
							<tbody>
								<tr>
									<td>IP سرور :</td>
									<td><?php echo get_client_ip(); ?></td>
								</tr>
								<tr>
									<td>نسخه PHP :</td>
									<td><?php echo function_exists('phpversion') ? phpversion() : ''; ?></td>
								</tr>
								<tr>
									<td>بررسی فعال بودن ماژول Soap :</td>
									<td><?php echo extension_loaded('soap') ? '<span style="color:#008000;font-weight:bold;">فعال</span>' : '<span style="color:#FF0000;font-weight:bold;">غیرفعال</span>'; ?></td>
								</tr>
								<tr>
									<td>بررسی فعال بودن ماژول cURL :</td>
									<td><?php echo extension_loaded('curl') ? '<span style="color:#008000;font-weight:bold;">فعال</span>' : '<span style="color:#FF0000;font-weight:bold;">غیرفعال</span>'; ?></td>
								</tr>
							</tbody> 
							<form action="" method="POST">
								<tbody>
									<tr>
										<td style="width:40%">مرچنت کد</td>
										<td><input type="text" class="form-control" name="MerchantCode" value=""/></td>
									</tr>
									<tr>
										<td>بررسی</td>
										<td><button class="btn btn-success" type="submit">بررسی</button></td>
									</tr>
									<?php if ( isset($_POST['MerchantCode']) ) { ?>										
									<tr>
										<td>نتیجه</td>
										<td>
										<?php echo behbank_Response( $_POST ); ?>
										</td>
									</tr>
									<?php } ?>
								</tbody> 
							</form>
						</table>
					</div>
				</div>
			</div> 
		</div>
	</div>
</body>
</html>
<?php
function get_client_ip() {
	
	$client_ip = '<span style="color:#FF0000;">خطا در دسترسی به IP هاست رخ داده است .</span>';
	
	if ( extension_loaded('curl')) {
		$ch = curl_init('http://behbank.com/files/ip.php');
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$client_ip = curl_exec($ch);
		curl_close($ch);
	}
	else if (function_exists('file_get_contents')) {
		$client_ip = file_get_contents('http://behbank.com/files/ip.php');
	}
	
	return $client_ip;
}

function behbank_Response( $post ) {
	
	if ( empty($post['MerchantCode']) ) {
		return $Response =	'<span style="color:#FF0000;">مرچنت کد را وارد نمایید .</span>';
	}
	
	if ( $_SERVER['SERVER_PORT'] != '80' ) {
		$ReturnUrl = $_SERVER['SERVER_NAME'] . ':' . $_SERVER['SERVER_PORT'] . $_SERVER['REQUEST_URI'];
	}
	else {
		$ReturnUrl = $_SERVER['SERVER_NAME'] . $_SERVER['REQUEST_URI'];
	}
	
	$Parameters = array(
		'SandBox'			  => false,
		'MerchantCode'  	  => strval($post['MerchantCode']),
		'PriceValue'   		  => 1000,
		'ReturnUrl'    		  => $ReturnUrl,
		'InvoiceNumber'		  => rand(1000,9999),
		'CustomQuery'   	  => array(),
		'CustomPost'          => array(),
		'PaymenterName'       => 'به بانک',
		'PaymenterEmail' 	  => 'info@behbank.com',
		'PaymenterMobile' 	  => '',
		'PluginName' 		  => 'Check Host',
		'PaymentNote'		  => 'تراکنش تستی جهت بررسی IP و فعال بودن ماژول های سرور',
		'ExtraAccountNumbers' => null,
		'Bank'				  => '',
	);
	
	if ( extension_loaded('soap') ) {
		try {
			$client  = new SoapClient('http://behbank.com/services/soap?wsdl', array('encoding' => 'UTF-8') );	
			$Request = $client->PaymentRequest( $Parameters );
		}
		catch(Exception $ex){
			$Message = $ex->getMessage();
		}
	}
	else if ( extension_loaded('curl') ) {
		try {
			$curl = curl_init();
			curl_setopt($curl, CURLOPT_URL, 'http://behbank.com/services/paymentRequest.json');
			curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type' => 'application/json'));
			curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($Parameters));
			curl_setopt($curl, CURLOPT_TIMEOUT, 400);
			curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
			$Request = json_decode(curl_exec($curl));
			curl_close($curl);
		}
		catch(Exception $ex){
			$Message = $ex->getMessage();
		}
	}
	else {
		$Request = json_decode(
			file_get_contents( 'http://behbank.com/services/paymentRequest.json', false, 
				stream_context_create(array('http' => 
						array(
							'method'  => 'POST',
							'header'  => 'Content-type: application/json',
							'content' => json_encode($Parameters) 
						)
					)
				)
			)
		);
	}
	
	if ( isset($Request->Status) && $Request->Status == 1 ){
	
		$Token = isset($Request->Token) ? $Request->Token : '';
		$Response =	'<span style="color:#008000;">مشکلی برای انجام تراکنش یافت نشد . شماره توکن : ' . $Token . ' </span>';
		
		$PluginType = '';
		if ( !extension_loaded('soap') && extension_loaded('curl') ) {
			$PluginType .= 'ولی نمی توان از پلاگین های وابسته به ماژول Soap استفاده کرد . باید از پلاگین های Restful یا NuSoap یا cURL استفاده کرد .';
		}
		else if ( extension_loaded('soap') && !extension_loaded('curl') ) {
			$PluginType .= 'ولی نمی توان از پلاگین های وابسته به ماژول cURL استفاده کرد . باید از پلاگین های Restful یا NuSoap یا Soap استفاده کرد .';
		}
		else if ( !extension_loaded('soap') && !extension_loaded('curl') ) {
			$PluginType .= 'ولی نمی توان از پلاگین های وابسته به ماژول Soap و یا cURL استفاده کرد . باید از پلاگین های Restful یا NuSoap استفاده کرد .';
		}
		
		$Response .=	'<span style="color:#FF0000;">' . $PluginType . '</span>';
		
	}
	else {
		$Message = isset($Request->Message) ? $Request->Message : ( !empty($Message) ? $Message : '');
		$Fault  = isset($Request->Status) ? behbank_Request_Results($Request->Status) : $Message;
		$Response =	'<span style="color:#FF0000;">' . $Fault . '</span>';
	}
	
	return $Response;
}

function behbank_Request_Results( $Fault ) {
	
	switch ($Fault) {

		case '-1' :
			$Response =	'نوع درخواست معتبر نیست .';
			break;
	
		case '-2' :
			$Response =	'مرچنت کد پذیرنده معتبر نیست .';
			break;

		case '-3' :
			$Response =	'شماره فاکتور معتبر نیست .';
			break;
	
		case '-4' :
			$Response =	'مقدار مبلغ معتبر نیست .';
			break;
	
		case '-5' :
			$Response =	'پست الکترونیکی پرداخت کننده معتبر نیست .';
			break;

		case '-6' :
			$Response =	'شماره موبایل پرداخت کننده معتبر نیست .';
			break;
	
		case '-7' :
			$Response =	'فیلدهای  Query String معتبر نیستند .';
			break;

		case '-8' :
			$Response =	'فیلدهای Post معتبر نیستند .';
			break;

		case '-9' :
			$Response =	'اطلاعات واریز به شماره حساب ها معتبر نیست .';
			break;

		case '-10' :
			$Response =	'کد درگاه معتبر نیست یا درگاه پذیرنده فعال نیست .';
			break;
	
		case '-11' :
			$Response =	'آدرس بازگشت به درگاه پذیرنده معتبر نیست .';
			break;
	
		case '-12' :
			$Response =	'مرچنت کد وارد شده برای این سایت نمی باشد .';
			break;
	
		case '-13' :
			$Response =	'آی پی درخواست کننده معتبر نیست .';
			break;
	
		case '-14' :
			$Response =	'بانک عامل معتبر نیست .';
			break;
	
		case '-15' :
			$Response =	'متاسفانه مشکلی در شبکه بانکی وجود دارد .';
			break;
	
		case '-16' :
			$Response =	'مقدار کلید پرداخت اشتباه است .';
			break;
	
		case '-17' :
			$Response =	'پرداخت قبلا استعلام شده و توسط بانک تایید نشده است .';
			break;
	
		case '-18' :
			$Response =	'پرداخت انجام نشده است .';
			break;
	
		case '-19' :
			$Response =	'پرداخت برگشت خورده است .';
			break;
	
		case '-20' :
			$Response =	'پرداخت توسط بانک تایید نشد .';
			break;

		case '-21' :
			$Response =	'پرداخت توسط بانک واریز نشد .';
			break;
				
		case '-22' :
			$Response =	'پرداخت برگشت زده شد .';
			break;
	
		case '-23' :
			$Response =	'پاسخی از بانک دریافت نشد .';
			break;
	
		case '-24' :
			$Response =	'اطلاعات پرداخت کننده معتبر نیست  (برای حالتی که با حساب به بانک پرداخت انجام میشود) .';
			break;

		case '-25' :
			$Response =	'خطا در پایگاه داده درگاه رخ داده است .';
			break;
				
		default :
			$Response =	'خطایی رخ داده است .';
			break;
	}
	return $Response;
}
?>